/* GetFile.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/dos.h>
#include <sys/iocs.h>
#include <errno.h>
#include <unistd.h>
#include <alloca.h>

#include <network.h>
#include <socket.h>

#ifdef	WEBXPRESSION
#include "../WebXpression.h"
extern void show_mouse_cursor (void);
extern void hide_mouse_cursor (void);
extern unsigned char hold_online;
unsigned char from_network;
#else
#include "../RoboGet.h"
extern char QuitCheck (void);
#endif

#include "../WebCache/WebCache.h"
#include "../FuncUrl/FuncUrl.h"

extern void Date2Date (char *, struct tm *);
extern void McPrint (char *);
extern void McDbPrint (char *);
extern void McCursorTop (void);
extern volatile signed char quit_flag;

static int inetd_version;

static char *content_type_str[]=
{"text/html", "text/html", "text/html", "text/plain", "text/plain",
 "image/gif", "image/jpeg", "image/jpeg", "image/ping", "image/bmp",
 "application/zip", "application/lzh", "application/gzip",
 "application/pdf",
 "application/octet-stream", "text/plain"};
static char *ext_type_str[]=
{"HTM", "HTML", "CGI", "TXT", "DOC",
 "GIF", "JPG", "JPEG", "PNG", "BMP",
 "ZIP", "LZH", "TGZ",
 "PDF",
 "DAT", "*/*"};

enum {
	REQ_HEAD,
	REQ_GET
};


int GetFileInit (void)
{
	if ((inetd_version = _get_version ())< 0) {
		printf ("m : TCP/IP hCo풓Ă܂B\n"
			"	[Jt@C^WebCache t@Ĉ݉{\łB\n");
	}
	return (0);
}


void HideMouse (void)
{
#ifdef	WEBXPRESSION
	int sp;

	from_network = !0;
	if (hold_online) {
		sp = _iocs_b_super (0);
		hide_mouse_cursor ();
		_iocs_b_super (sp);
	}
#endif
}

void ShowMouse (void)
{
#ifdef	WEBXPRESSION
	int sp;

	from_network = 0;
	if (hold_online) {
		sp = _iocs_b_super (0);
		show_mouse_cursor ();
		_iocs_b_super (sp);
	}
#endif
}



/* URL Ŏw肵t@Clbg[NĂ */
static signed char GetFromNetwork (HTTPFILE * httpfile, char req_mode)
{
	int netd;
	struct sockaddr_in addr;
	struct hostent *h;
	char scheme[256], hostname[256], path[256], fname[256], query[256], anchor[256];
	int port;
	char temp_str[1024];

	httpfile->content_length = 0;
	*httpfile->content_type = '\0';
	httpfile->content = NULL;

#define NO_TIMESTAMP	255
	(httpfile->time_stamp).tm_sec = NO_TIMESTAMP;

	UrlSplit (httpfile->url, scheme, hostname, path, fname, query, anchor, &port);

    /* \Pbg쐬 */
	if ((netd = socket (AF_INET, SOCK_STREAM, 0)) < 0) {
		McPrint (" \Pbg쐬ł܂ł\n");
		return (-1);
	}
	memset (&addr, 0, sizeof (addr));	/* 0 Ŗ߂ */

	addr.sin_family = AF_INET;	/* INEThCw */
	addr.sin_port = htons (port);	/* http ̓|[g 80 */
    /* zXg(www.xxx.co.jp)  IP AhX(int)ɕϊ */
	if ((h = gethostbyname (hostname)) == NULL) {
		McPrint ("hC݂܂\n");
		return (-1);
	}
	addr.sin_addr.s_addr = *(long *) h->h_addr;

    /* ɐڑ */
	if (req_mode == REQ_HEAD)
		McDbPrint ("wb_擾܂");
	McPrint (hostname);
	McPrint (" ɐڑ...");
	if (connect (netd, (char *) &addr, sizeof (addr)) < 0) {
		McPrint ("\n ڑɎs܂\n");
		return (-1);
	}
	McCursorTop ();
	McPrint (hostname);
	McPrint (" ɐڑ܂\n");

	if (req_mode == REQ_HEAD)
		sprintf (temp_str, "HEAD %s%s%s HTTP/1.0\r\n", path, fname, query);
	else
		sprintf (temp_str, "GET %s%s%s HTTP/1.0\r\n", path, fname, query);
	McDbPrint (temp_str);
	write_s (netd, temp_str, strlen (temp_str));
    /* write_s (netd, "User-Agent: WebXpression / ver0.01 (X68000)\r\n", 48);	 */
	strcpy (temp_str, "Accept: */*\r\n");
	write_s (netd, temp_str, strlen (temp_str));
	sprintf (temp_str, "Host: %s\r\n", hostname);
	write_s (netd, temp_str, strlen (temp_str));
	write_s (netd, "\r\n", 2);

	McPrint ("X|X҂܂...");

    /* wb_PsÂǂݍ */
	recvline (netd, temp_str, 1024);
	if ((strncmp (temp_str, "HTTP/1.0 200", 12))
	    && (strncmp (temp_str, "HTTP/1.1 200", 12))) {
		McDbPrint (temp_str);
		close_s (netd);	/* ڑ̐ؒf */
		return (-1);
	}
	McCursorTop ();		/* "X|X҂܂" */

    /* siwb_̏Ij܂Ń[v */
	while (recvline (netd, temp_str, 1024), strlen (temp_str) > 3) {
		char temp_entity[256];

		McDbPrint ("HEAD > ");
		McDbPrint (temp_str);

		sscanf (temp_str, "%s", temp_entity);
	    /* wb_͑啶^ʂȂ */
		if (!stricmp (temp_entity, "Content-Type:")) {
			sscanf (temp_str + 14, "%s", httpfile->content_type);
		}
		if (!stricmp (temp_entity, "Content-Length:")) {
			sscanf (temp_str + 16, "%d", &httpfile->content_length);
		}
		if (!stricmp (temp_entity, "Last-Modified:")) {
			Date2Date (temp_str + 15, &(httpfile->time_stamp));
		}
	}
	if (*httpfile->content_type == '\0')
		strcpy (httpfile->content_type, "application/octet-stream");


	if (req_mode == REQ_HEAD) {
		close_s (netd);	/* ڑ̐ؒf */

		if ((httpfile->time_stamp).tm_sec == NO_TIMESTAMP) {
			time_t t;
			t = time (NULL);
			httpfile->time_stamp = *localtime (&t);
		}
		McCursorTop ();
		McPrint ("wb_擾܂\n");
	} else {
		FILE *fp;
		int read_size = 0, s;
		void *r = NULL;
		int alloc_size, alloc_left;
		int lap_time;
		char cache_fname[256];

#define YOYUU	4096
		if (httpfile->content_length) {
			alloc_size = httpfile->content_length + YOYUU;
		} else {
		    /* 12MB ȏmۂłȂ[ */
			alloc_size = ((int) _dos_malloc (-1)) & 0x00fffffe - YOYUU;
		}
		if (((int) (httpfile->content = _dos_malloc (alloc_size))) < 0) {
			McPrint (" ܂\n");
			close_s (netd);	/* ڑ̐ؒf */
			httpfile->content = NULL;
			return (-1);
		}
		r = httpfile->content;
		alloc_left = alloc_size;
		lap_time = _iocs_ontime ();
		quit_flag = QUIT_NON;
		while ((socklen (netd, 0) >= 0) && (quit_flag == QUIT_NON)) {
			s = read_s (netd, r, alloc_left);
			read_size += s;
			r += s;
			if ((alloc_left -= s) <= 0) {
				McPrint (" ܂\n");
				break;
			}
#if	1
			if (httpfile->content_length)
				sprintf (temp_str, "M %d/%d oCg", read_size, httpfile->content_length);
			else
				sprintf (temp_str, "M %d oCg", read_size);
			McCursorTop ();	/* J[\s̐擪 */
			McPrint (temp_str);
#endif
#ifndef	WEBXPRESSION
			quit_flag = QuitCheck ();
#endif
		}
		if (quit_flag != QUIT_NON){
			shutdown(netd,0); /* Mf[^󂯎炸CׂĔp */
			shutdown(netd,2); /* connection  abort */
		}
		close_s (netd);	/* ڑ̐ؒf */
		lap_time -= _iocs_ontime ();
		McCursorTop ();	/* J[\s̐擪 */

#ifndef WEBXPRESSION
		sprintf (temp_str, "	MIiMx %8.1f oCg^błj", (double) read_size / (double) (-lap_time) * 100.0);
		McPrint (temp_str);
#endif

		if (!(httpfile->content_length)) {
			_dos_setblock (httpfile->content, read_size);
			httpfile->content_length = read_size;
			if (alloc_left <= 0) {
				_dos_mfree (httpfile->content);
				httpfile->content = NULL;
				return (-1);
			}
		}
		if (quit_flag == QUIT_NON) {
			time_t t;
			if ((httpfile->time_stamp).tm_sec != NO_TIMESTAMP) {
				t = mktime (&httpfile->time_stamp);
			} else {
				t = time (NULL);
				httpfile->time_stamp = *localtime (&t);
			}
			WCInsertUrl (httpfile, cache_fname);
			if ((fp = fopen (cache_fname, "wb")) != NULL) {
				struct utimbuf u;
				fwrite (httpfile->content, sizeof (char), read_size, fp);
				fclose (fp);
				u.actime = t + 32400;
				u.modtime = t + 32400;
				utime (cache_fname, &u);
#ifndef WEBXPRESSION
				McPrint (" : t@Cۑ܂\n");
#endif
			}
		} else {
			McPrint (" f܂\n");
			_dos_mfree (httpfile->content);
			httpfile->content = NULL;
		}
	}
	return (0);
}



/* URL Ŏw肵t@CfBXNĂ */
static void GetFromLocal (HTTPFILE * httpfile)
{
	FILE *fp;
	char scheme[256], hostname[256], path[256], fname[256], query[256], anchor[256];
	int port;
	char temp_str[256], ext[256];

	*httpfile->content_type = '\0';
	httpfile->content_length = 0;

	UrlSplit (httpfile->url, scheme, hostname, path, fname, query, anchor, &port);
	strcpy (temp_str, hostname);
	strcat (temp_str, path);
	strcat (temp_str, fname);
	if ((fp = fopen (temp_str, "rb")) != NULL) {
		int i;
		char c;
		char *p;

		httpfile->content_length = filelength (fileno (fp));
		if ((int) (httpfile->content = _dos_malloc (httpfile->content_length)) > 0) {
			fread (httpfile->content, httpfile->content_length, 1, fp);
			fclose (fp);

		    /* }`sIhΉEEE */
			ext[0] = '\0';
			p = &fname[0];
			while (c = *p++) {
				if (c == '.') {
					strcpy (ext, p);
					break;
				}
			}

			for (i = 0; i < sizeof (ext_type_str) / sizeof (char *)- 1; i++) {
				if (!stricmp (ext, ext_type_str[i]))
					break;
			}
			strcpy (httpfile->content_type, content_type_str[i]);
		    /* A^CX^v̏܂ */

		} else {
			McDbPrint ("GetFromLocal() : ");
			McPrint (" : ܂\n");
			httpfile->content = NULL;
		}
	} else {
		McDbPrint ("GetFromLocal() : ");
		McPrint (" : [Jt@C \n");
		McPrint (httpfile->url);
		McPrint (" I[vł܂\n");
	}
	return;
}



/* URL Ŏw肵t@CLbVĂ */
static void GetFromCache (HTTPFILE * httpfile, char *cache_fname)
{
	FILE *fp;

#ifndef WEBXPRESSION
	if (!strcmp (httpfile->content_type, "text/html"))
		return;
#endif
	McDbPrint ("LbV ");
	McDbPrint (cache_fname);
	McDbPrint (" ǂݍ݂܂\n");

	if ((fp = fopen (cache_fname, "rb")) != NULL) {
		if ((int) (httpfile->content = _dos_malloc (httpfile->content_length)) > 0) {
			fread (httpfile->content, httpfile->content_length, sizeof (char), fp);
		} else {
			McPrint (" ܂\n");
			httpfile->content = NULL;
		}
		fclose (fp);
	} else {
		McPrint (" LbVt@C ");
		McPrint (cache_fname);
		McPrint (" I[vł܂\n");
	}
	return;
}



/* URL Ŏw肵t@CĂ */
int GetFile (HTTPFILE * httpfile)
{
	char cache_fname[256];
	char head_flag;

	McDbPrint ("GetFile() : ");
	McDbPrint (httpfile->url);
	McDbPrint (" ̎MJn܂");

	httpfile->content = NULL;

	switch (WCExist (httpfile, cache_fname)) {
	case WC_NON:		/* LbVɑ݂Ȃꍇ */
		McDbPrint (" / WC_NON\n");
		if (inetd_version >= 0) {
		    /* TCP/IP hCo풓Ăꍇ */
			HideMouse ();
			GetFromNetwork (httpfile, REQ_GET);
			ShowMouse ();
		} else {
			McPrint (" TCP/IP hCo풓Ă܂\n");
		}
		break;

	case WC_INCACHE:	/* LbVɑ݂AN㏉߂ẴANZX̏ꍇ */
		McDbPrint (" / WC_INCACHE\n");
		WCSetAccess (httpfile);
		if (inetd_version >= 0) {
		    /* TCP/IP hCo풓Ăꍇ */
			HTTPFILE *httpfile2;	/* wb_Ԃ */

			httpfile2 = alloca (sizeof (HTTPFILE));
			strcpy (httpfile2->url, httpfile->url);
			HideMouse ();
			head_flag = GetFromNetwork (httpfile2, REQ_HEAD);	/* wb_擾 */
			ShowMouse ();
			if (!head_flag) {
			    /* wb_擾oꍇ */
				McDbPrint ("wb_擾\n");
				if (difftime (mktime (&httpfile2->time_stamp), mktime (&httpfile->time_stamp)) > (double) 0.0) {
				    /* t@CXVĂꍇ */
					McDbPrint ("t@CXVĂ܂\n");
					HideMouse ();
					GetFromNetwork (httpfile, REQ_GET);
					ShowMouse ();
					if (httpfile->content != NULL) {
						WCDeleteUrl (httpfile->url);
						remove (cache_fname);
					}
				} else {
				    /* t@CXVĂȂꍇ */
					McDbPrint ("t@CXVĂ܂\n");
					GetFromCache (httpfile, cache_fname);
				}
			} else {
			    /* wb_擾łȂꍇ */
				GetFromCache (httpfile, cache_fname);
			}
		} else {
		    /* TCP/IP hCo풓ĂȂꍇ */
			GetFromCache (httpfile, cache_fname);
		}
		break;

	case WC_INCACHE2:	/* LbVɑ݂ANPȏANZXĂꍇ */
		McDbPrint (" / WC_INCACHE2\n");
		GetFromCache (httpfile, cache_fname);
		break;

	case WC_LOCAL:
		McDbPrint (" / WC_LOCAL\n");
		GetFromLocal (httpfile);
		break;
	}

	if (httpfile->content == NULL)
		return (-1);

	return (0);
}
